<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

// L'accès est autorisé uniquement aux colleurs et professeurs
$mysqli = premiere_connexion();
if ( !$autorisation )  {
  $p = 'mail';
  $t = 'Envoi de mail';
  include('login.php');
}
if ( $autorisation < 2 )
  exit('Cette page ne contient aucune information.');

// Récupération des préférences d'envoi (mailexp, mailsign, mailcopy) de l'utilisateur
$resultat = $mysqli->query("SELECT nom, prenom, genre, mail, mailexp, IF(mailcopy,' checked','') AS mailcopybox, mailcopy
                            FROM utilisateurs WHERE id = ${_SESSION['id']}");
$u = $resultat->fetch_assoc();
$resultat->free();

// Impossible d'aller plus loin si le mail n'est pas renseigné ou si mailexp est
// nul : possibilité de désactivation
if ( !strlen($u['mail']) || !$u['mailexp'] )  {
  $p = "mail";
  $t = 'Envoi de mail';
  $message = ( strlen($u['mail']) ) ? 'Vous n\'êtes pas autorisé à envoyer de mails. Il faut demander au professeur de votre matière l\'autorisation.' : 'Il est impossible d\'envoyer des mails sans avoir renseigné une adresse mail qui sera écrite en tant qu\'expéditeur. Il faut aller voir vos <a href="prefs">Préférences</a> pour mettre à jour votre identité.';
  include('haut.php');
  include('bas.php');
  exit();
}

// Champ expéditeur
switch ( $u['genre'] )  {
  case 1 : $g = 'M. '; break;
  case 2 : $g = 'Mme '; break;
  case 3 : $g = 'Melle '; break;
  default : $g = '';
}
switch ( $u['mailexp'] )  {
  case 1 : $exp = "$g${u['nom']}"; break;
  case 2 : $exp = "$g${u['prenom']} ${u['nom']}"; break;
  case 3 : $exp = "${u['prenom']} ${u['nom']}"; break;
  case 4 : $exp = "${u['nom']}"; break;
}

///////////////////
// Envoi du mail //
///////////////////
if ( isset($_REQUEST['valide']) && isset($_REQUEST['dest']) )  {
  // Récupération des destinataires
  $resultat = $mysqli->query("SELECT id, mail, CASE autorisation WHEN autorisation = 2 THEN CONCAT( prenom, ' ', nom )
                                               ELSE CONCAT( CASE MOD(genre,5) WHEN 1 THEN 'M. ' WHEN 2 THEN 'Mme ' WHEN 3 THEN 'Melle ' END, nom ) END AS nom_complet
                              FROM utilisateurs WHERE login NOT RLIKE '^tmp[0-9]{5}' AND LENGTH(mail) > 0 AND id != ${_SESSION['id']} ORDER BY autorisation DESC, nom");
  while ( $r = $resultat->fetch_assoc() )
    $utilisateurs[$r['id']] = $r;
  $dests = '';
  $ids = explode(',',implode(',',$_REQUEST['dest']));
  foreach ( $ids as $i )
    if ( isset($utilisateurs[$i]) )  {
      $dests .= $utilisateurs[$i]['nom_complet'].' <'.$utilisateurs[$i]['mail'].'>, ';
      unset($utilisateurs[$i]);
    }
  if ( !strlen($dests) )
    $message = 'Le mail n\'a pas été envoyé car aucun destinataire n\'a été renseigné.';
  else  {
    $dests = substr($dests,0,-2);
    $bcc = ( $u['mailcopy'] ) ? "$exp <${u['mail']}>, " : '';
    if ( isset($_REQUEST['dest_bcc']) )
      $ids = explode(',',implode(',',$_REQUEST['dest_bcc']));
      foreach ( $ids as $i )
        if ( isset($utilisateurs[$i]) )  {
          $bcc .= $utilisateurs[$i]['nom_complet'].' <'.$utilisateurs[$i]['mail'].'>, ';
          unset($utilisateurs[$i]);
        }
    $bcc = ( strlen($bcc) ) ? 'Bcc: '.substr($bcc,0,-2) : '';
    mail($dests,$_REQUEST['sujet'],$_REQUEST['texte'],"From: $exp <${u['mail']}>\r\nContent-type: text/plain; charset=UTF-8\r\n$bcc");
    // Message de confirmation d'envoi
    $n1 = substr_count($dests,'<');
    $n2 = substr_count($bcc,'<') - $u['mailcopy'];
    if ( $n2 )
      $message = 'Le mail a été envoyé à '.($n1+$n2).' destinataires (dont '.$n2.' en copie cachée).';
    else
      $message = ( $n1 > 1 ) ? "Le mail a été envoyé à $n1 destinataires." : 'Le mail a été envoyé à un destinataire.';
  }
}

//////////
// HTML //
//////////
// Haut de page, menu et message
$p = "mail";
$t = 'Envoi de mail';
include('haut.php');

// Aide générale et formulaires
?>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous envoyer un mail aux utilisateurs ayant renseigné leur adresse mail.</p>
    <h4>Destinataires</h4>
    <p>Les cases à cocher <em>Copie</em> permettre d'ajouter les utilisateurs cochés dans la liste des destinataires. Il est obligatoire qu'au moins un utilisateur soit destinataire.</p>
    <p>Les cases à cocher <em>Copie cachée</em> permettre d'ajouter les utilisateurs cochés dans la liste des destinataires en copie cachée&nbsp;: les autres destinataires ne verront pas que ce mail a aussi été envoyé à ceux en copie cachée.</p>
    <p>Un utilisateur ne peut pas être à la fois en copie et en copie cachée.</p>
    <p>Les case à cocher sont grisées si l'utilisateur n'a pas renseigné son adresse mail.</p>
    <h4>Groupes d'élèves</h4>
    <p>Il est possible de créer et de modifier des groupes d'élèves sur la page <a href="groupes">Groupes d'élèves</a>.</p>
    <p>Une fois les groupes d'élèves créés, cocher un groupe permet d'envoyer le mail à tous les élèves du groupe ayant renseigné leur adresse mail (les élèves correspondants au groupe sont automatiquement cochés).</p>
    <p>Le décochage d'un groupe ne décoche pas automatiquement les élèves du groupe.</p>
    <p>Un élève appartenant à deux groupes cochés ne recevra qu'une seule fois le mail.</p>
    <h4>Sujet et contenu du mail</h4>
    <p>Le <em>sujet</em> est le sujet du mail. Tous les caractères sont autorisés. Pensez à envoyer des mails avec un sujet correspondant explicitement au contenu...</p>
    <p>Le <em>contenu</em> est le corps du mail, en texte brut. Le mail envoyé ne sera pas formaté en HTML&nbsp;: il n'est pas possible de réaliser un formattage particulier (changer une taille d'écriture, une police, mettre de la couleur...). Par convention classique,</p>
    <ul>
      <li>écrire un mot entre astérisques (*) signifie le mettre en gras et appuyer sur ce mot.</li>
      <li>écrire un mot entre slashes (/) signifie le mettre en italique pour indiquer qu'il faut y faire attention.</li>
      <li>écrire en majuscules signifie que l'on en train d'hurler. :-)</li>
    </ul>
    <h4>Autres réglages</h4>
    <p>Vous pouvez aussi modifier légèrement ce qui apparaîtra comme expéditeur de tous vos mails (actuellement <code><?php echo "$exp &lt;${u['mail']}&gt;"; ?></code>). C'est une des préférences techniques, accessible dans vos <a href="prefs">Préférences</a>.</p>
    <p>Vous pouvez être de façon automatique en copie de tous vos mails. C'est une des préférences techniques, accessible dans vos <a href="prefs">Préférences</a>.</p>
  </div>

<?php
// Récupération des utilisateurs
$resultat = $mysqli->query("SELECT id, login, IF(LENGTH(mail),'',' disabled') AS mail, autorisation,
                            CONCAT( CASE MOD(genre,5) WHEN 1 THEN 'M. ' WHEN 2 THEN 'Mme ' WHEN 3 THEN 'Melle ' ELSE '' END, prenom, ' ', nom ) AS nom_complet
                            FROM utilisateurs WHERE login NOT RLIKE '^tmp[0-9]{5}' AND id != ${_SESSION['id']} AND autorisation > 1 ORDER BY autorisation DESC, nom");
?>
  <div class="item admin nojs">
  <form action="" method="post">
    <input class="bouton" type="submit" name="valide" value="Envoyer le mail">
    <h3>Destinataires</h3>
    <table class="admin" id="dests">
      <tbody>
        <tr><td></td><td class="checks">Copie</td><td class="checks">Copie cachée</td></tr>
<?php
$a = 0;
while ( $r = $resultat->fetch_assoc() )  {
  if ( $a != $r['autorisation'] )  {
    $a = $r['autorisation'];
    switch ( $a )  {
      case 2 : $t = 'Élèves'; break;
      case 3 : $t = 'Colleurs'; break;
      case 4 : $t = 'Professeurs'; break;
    }
    echo "        <tr><th>$t</th><td></td><td></td></tr>\n";
  }
  $nom = ( strlen($r['nom_complet']) > 1 ) ? $r['nom_complet'] : "<em>${r['login']}</em>";
  if ( strlen($r['mail']) )
    $nom .= ' (pas de mail)';
  echo "        <tr><td>$nom</td><td><input type=\"checkbox\" class=\"dest_c$a\" name=\"dest[]\" value=\"${r['id']}\"${r['mail']}></td><td><input type=\"checkbox\" class=\"dest_bcc$a\" name=\"dest_bcc[]\" value=\"${r['id']}\"${r['mail']}></td></tr>\n";
}
$resultat->free();

// Affichage des groupes d'élèves
$resultat = $mysqli->query('SELECT g.id, g.nom, g.eleves AS eid,
                            GROUP_CONCAT( CONCAT(e.prenom,\' \',e.nom) ORDER BY FIND_IN_SET(e.id,g.eleves) SEPARATOR \', \') AS eleves
                            FROM groupes AS g JOIN utilisateurs AS e ON FIND_IN_SET(e.id,g.eleves) GROUP BY g.id ORDER BY g.nom_nat');
if ( $resultat->num_rows )  {
  echo "        <tr><th>Groupes d'élèves</th><td></td><td></td></tr>\n";
  while ( $r = $resultat->fetch_assoc() )  {
    echo "        <tr><td>Groupe ${r['nom']}&nbsp;: ${r['eleves']}</td><td><input type=\"checkbox\" class=\"dest_c5\" name=\"dest[]\" value=\"${r['eid']}\"></td><td><input type=\"checkbox\" class=\"dest_bcc5\" name=\"dest_bcc[]\" value=\"${r['eid']}\"></td></tr>\n";
  }
  $resultat->free();
}
$mysqli->close();
?>
      </tbody>
    </table>

    <script type="text/javascript">
$( function() {
  // Pliage du tableau des destinataires
  $('#dests').hide().prev('h3').append(' <span id="deplie">déplier</span>');
  $('#deplie').click( function () {
    $('#dests').toggle();
    $(this).text($(this).text() == 'déplier' ? 'replier' : 'déplier');
  });
  
  // Pliage de l'aide
  $('.aide h3').append(' <span>déplier</span>');
  $('.aide h3 span').click( function () {
    $('.aide').children(':not(h3)').toggle();
    $(this).text($(this).text() == 'déplier' ? 'replier' : 'déplier');
  });
  $('.aide').children(':not(h3)').hide();

  // Bouton de sélection multiple
  $('#dests th').next().append('<input type="button" class="button_c" value="Tout cocher">');
  $('#dests th').next().next().append('<input type="button" class="button_bcc" value="Tout cocher">');
  $('.button_c,.button_bcc').click( function () {
    var a = $(this).closest('tr').next().find('input[name=dest\\[\\]]').attr('class').substr(6);
    var t1 = $(this).attr('class').substr(7);
    var t2 = ( t1 == 'c' ? 'bcc' : 'c' );
    if ( $(this).val() == 'Tout cocher' )  {
      $(this).val('Tout décocher');
      $('.dest_'+t1+a+':not(:disabled)').prop("checked",true);
      $('.dest_'+t2+a+':not(:disabled)').prop("checked",false);
      $(this).closest('tr').find('.button_'+t2).val('Tout cocher');
    }
    else  {
      $(this).val('Tout cocher');
      $('.dest_'+t1+a).prop("checked",false);
    }
    verif_dest();
  });
  $('input[name*=dest]').click( function () {
    if ( $(this).is(':checked') )
      $(this).closest('tr').find( $(this).attr('class').length > 8 ? '.dest_c'+$(this).attr('class').substr(8) : '.dest_bcc'+$(this).attr('class').substr(6) ).prop("checked",false);
    verif_dest();
  });

  // Vérification qu'au moins un destinataire a été sélectionné
  function verif_dest() {
    var a = $('#avertissement_destinataires').length;
    var i = $('input[name=dest\\[\\]]:checked').length;
    if ( !a && !i )  {
      $('#dests').after('<p id="avertissement_destinataires" class="warning">Aucun destinataire n\'a été sélectionné. Il en faut un au minimum.</p>');
      $('input[name=valide]').prop('disabled',true);
    }
    if ( a && i )  {
      $('#avertissement_destinataires').remove();
      $('input[name=valide]').prop('disabled',false);
    }
  }
  verif_dest();
  
});
    </script>

    <h3>Sujet</h3>
    <textarea class="nojs" name="sujet" rows="1" cols="100"></textarea>
    <input class="bouton" type="submit" name="valide" value="Envoyer le mail">
    <h3>Contenu</h3>
    <textarea class="nojs" name="texte" rows="30" cols="100"><?php echo "Bonjour à tous\n\n\n\n\n-- \n$exp"; ?></textarea>
<?php
// Pour info, l'expéditeur
$u['mailcopy'] = ( $u['mailcopy'] ) ? 'Vous recevrez' : 'Vous ne recevrez pas';
echo "
    <p>L'expéditeur du mail apparaîtra comme &laquo;&nbsp;<code>$exp &lt;${u['mail']}&gt;</code>&nbsp;&raquo;. Ceci est modifiable dans vos <a href=\"prefs\">Préférences</a>.</p>
    <p>${u['mailcopy']} une copie de ce mail dans votre boîte mail. Ceci est modifiable dans vos <a href=\"prefs\">Préférences</a>.</p>
  </form>
  </div>\n";

// Bas de page
include('bas.php');
?>
